<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>ZipSecureFile (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="ZipSecureFile (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":9,"i2":9,"i3":9,"i4":10,"i5":9,"i6":9,"i7":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/ZipSecureFile.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/openxml4j/util/ZipInputStreamZipEntrySource.html"
               title="class in org.apache.poi.openxml4j.util"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li>Next&nbsp;Class</li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/openxml4j/util/ZipSecureFile.html"
               target="_top">Frames</a></li>
        <li><a href="ZipSecureFile.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.openxml4j.util</div>
    <h2 title="Class ZipSecureFile" class="title">Class ZipSecureFile</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.commons.compress.archivers.zip.ZipFile</li>
                <li>
                    <ul class="inheritance">
                        <li>org.apache.poi.openxml4j.util.ZipSecureFile</li>
                    </ul>
                </li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <dl>
                    <dt>All Implemented Interfaces:</dt>
                    <dd>java.io.Closeable, java.lang.AutoCloseable</dd>
                </dl>
                <hr>
                <br>
                <pre>public class <span class="typeNameLabel">ZipSecureFile</span>
extends org.apache.commons.compress.archivers.zip.ZipFile</pre>
                <div class="block">This class wraps a <code>ZipFile</code> in order to check the
                    entries for <a href="https://en.wikipedia.org/wiki/Zip_bomb">zip bombs</a>
                    while reading the archive.<p>

                        The alert limits can be globally defined via <a
                            href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#setMaxEntrySize-long-"><code>setMaxEntrySize(long)</code></a>
                        and <a
                            href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#setMinInflateRatio-double-"><code>setMinInflateRatio(double)</code></a>.
                </div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#ZipSecureFile-java.io.File-">ZipSecureFile</a></span>(java.io.File&nbsp;file)</code>&nbsp;
                                </td>
                            </tr>
                            <tr class="rowColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#ZipSecureFile-java.lang.String-">ZipSecureFile</a></span>(java.lang.String&nbsp;name)</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a
                                    href="javascript:show(2);">Instance Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipArchiveThresholdInputStream.html"
                                        title="class in org.apache.poi.openxml4j.util">ZipArchiveThresholdInputStream</a></code>
                                </td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#getInputStream-org.apache.commons.compress.archivers.zip.ZipArchiveEntry-">getInputStream</a></span>(org.apache.commons.compress.archivers.zip.ZipArchiveEntry&nbsp;entry)</code>
                                    <div class="block">Returns an input stream for reading the contents of the specified
                                        zip file entry.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>static long</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#getMaxEntrySize--">getMaxEntrySize</a></span>()</code>
                                    <div class="block">Returns the current maximum allowed uncompressed file size.</div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>static long</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#getMaxTextSize--">getMaxTextSize</a></span>()</code>
                                    <div class="block">Returns the current maximum allowed text size.</div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>static double</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#getMinInflateRatio--">getMinInflateRatio</a></span>()</code>
                                    <div class="block">Returns the current minimum compression rate that is used.</div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#getName--">getName</a></span>()</code>
                                    <div class="block">Returns the path name of the ZIP file.</div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#setMaxEntrySize-long-">setMaxEntrySize</a></span>(long&nbsp;maxEntrySize)</code>
                                    <div class="block">Sets the maximum file size of a single zip entry.</div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#setMaxTextSize-long-">setMaxTextSize</a></span>(long&nbsp;maxTextSize)</code>
                                    <div class="block">Sets the maximum number of characters of text that are
                                        extracted before an exception is thrown during extracting
                                        text from documents.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipSecureFile.html#setMinInflateRatio-double-">setMinInflateRatio</a></span>(double&nbsp;ratio)</code>
                                    <div class="block">Sets the ratio between de- and inflated bytes to detect
                                        zipbomb.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a
                                    name="methods.inherited.from.class.org.apache.commons.compress.archivers.zip.ZipFile">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from
                                    class&nbsp;org.apache.commons.compress.archivers.zip.ZipFile</h3>
                                <code>canReadEntryData, close, closeQuietly, copyRawEntries, finalize, getEncoding,
                                    getEntries, getEntries, getEntriesInPhysicalOrder, getEntriesInPhysicalOrder,
                                    getEntry, getRawInputStream, getUnixSymlink</code></li>
                        </ul>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait,
                                    wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="ZipSecureFile-java.io.File-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>ZipSecureFile</h4>
                                <pre>public&nbsp;ZipSecureFile(java.io.File&nbsp;file)
              throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="ZipSecureFile-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>ZipSecureFile</h4>
                                <pre>public&nbsp;ZipSecureFile(java.lang.String&nbsp;name)
              throws java.io.IOException</pre>
                                <dl>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="setMinInflateRatio-double-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setMinInflateRatio</h4>
                                <pre>public static&nbsp;void&nbsp;setMinInflateRatio(double&nbsp;ratio)</pre>
                                <div class="block">Sets the ratio between de- and inflated bytes to detect zipbomb.
                                    It defaults to 1% (= 0.01d), i.e. when the compression is better than
                                    1% for any given read package part, the parsing will fail indicating a
                                    Zip-Bomb.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>ratio</code> - the ratio between de- and inflated bytes to detect zipbomb
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getMinInflateRatio--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getMinInflateRatio</h4>
                                <pre>public static&nbsp;double&nbsp;getMinInflateRatio()</pre>
                                <div class="block">Returns the current minimum compression rate that is used.

                                    See setMinInflateRatio() for details.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The min accepted compression-ratio.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setMaxEntrySize-long-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setMaxEntrySize</h4>
                                <pre>public static&nbsp;void&nbsp;setMaxEntrySize(long&nbsp;maxEntrySize)</pre>
                                <div class="block">Sets the maximum file size of a single zip entry. It defaults to 4GB,
                                    i.e. the 32-bit zip format maximum.

                                    This can be used to limit memory consumption and protect against
                                    security vulnerabilities when documents are provided by users.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>maxEntrySize</code> - the max. file size of a single zip entry</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getMaxEntrySize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getMaxEntrySize</h4>
                                <pre>public static&nbsp;long&nbsp;getMaxEntrySize()</pre>
                                <div class="block">Returns the current maximum allowed uncompressed file size.

                                    See setMaxEntrySize() for details.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The max accepted uncompressed file size.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="setMaxTextSize-long-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>setMaxTextSize</h4>
                                <pre>public static&nbsp;void&nbsp;setMaxTextSize(long&nbsp;maxTextSize)</pre>
                                <div class="block">Sets the maximum number of characters of text that are
                                    extracted before an exception is thrown during extracting
                                    text from documents.

                                    This can be used to limit memory consumption and protect against
                                    security vulnerabilities when documents are provided by users.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>maxTextSize</code> - the max. file size of a single zip entry</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getMaxTextSize--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getMaxTextSize</h4>
                                <pre>public static&nbsp;long&nbsp;getMaxTextSize()</pre>
                                <div class="block">Returns the current maximum allowed text size.

                                    See setMaxTextSize() for details.
                                </div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>The max accepted text size.</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getInputStream-org.apache.commons.compress.archivers.zip.ZipArchiveEntry-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getInputStream</h4>
                                <pre>public&nbsp;<a
                                        href="../../../../../org/apache/poi/openxml4j/util/ZipArchiveThresholdInputStream.html"
                                        title="class in org.apache.poi.openxml4j.util">ZipArchiveThresholdInputStream</a>&nbsp;getInputStream(org.apache.commons.compress.archivers.zip.ZipArchiveEntry&nbsp;entry)
                                              throws java.io.IOException</pre>
                                <div class="block">Returns an input stream for reading the contents of the specified
                                    zip file entry.

                                    <p> Closing this ZIP file will, in turn, close all input
                                        streams that have been returned by invocations of this method.</div>
                                <dl>
                                    <dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
                                    <dd><code>getInputStream</code>&nbsp;in class&nbsp;<code>org.apache.commons.compress.archivers.zip.ZipFile</code>
                                    </dd>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>entry</code> - the zip file entry</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the input stream for reading the contents of the specified
                                        zip file entry.
                                    </dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.io.IOException</code> - if an I/O error has occurred</dd>
                                    <dd><code>java.lang.IllegalStateException</code> - if the zip file has been closed
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getName--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>getName</h4>
                                <pre>public&nbsp;java.lang.String&nbsp;getName()</pre>
                                <div class="block">Returns the path name of the ZIP file.</div>
                                <dl>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the path name of the ZIP file</dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/ZipSecureFile.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/openxml4j/util/ZipInputStreamZipEntrySource.html"
               title="class in org.apache.poi.openxml4j.util"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li>Next&nbsp;Class</li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/openxml4j/util/ZipSecureFile.html"
               target="_top">Frames</a></li>
        <li><a href="ZipSecureFile.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
